Subject: Re: linux-next: build warning after merge of the scsi tree

From: James Bottomley <[email-masked]>
Date: Wed, 10 Feb 2010 17:13:51 -0500

On Wed, 2010-02-10 at 16:51 +1100, Stephen Rothwell wrote:
> Hi all,
> 
> After merging the percpu tree, today's linux-next build (powerpc
> ppc64_defconfig) produced these warnings:
> 
> drivers/scsi/qla2xxx/qla_attr.c: In function 'qla2x00_process_vendor_specific':
> drivers/scsi/qla2xxx/qla_attr.c:2150: warning: 'req_data' may be used uninitialized in this function
> drivers/scsi/qla2xxx/qla_attr.c:2152: warning: 'req_data_len' may be used uninitialized in this function
> 
> If the first "goto done_unmap_sg;" in this function is followed, the
> req_data will be tested even though it has not been assigned to yet and
> if it is non zero, it and req_data_len will be passed to
> dma_free_coherent() while still uninitialised.
> 
> Introduced by commit 9a069e196767d7b87184fd8d8211d22bb5b9c0b8 ("[SCSI]
> qla2xxx: Add BSG support for FC ELS/CT passthrough and vendor commands").
> 
> The compiler also produces these:
> 
> drivers/scsi/qla2xxx/qla_attr.c:2144: warning: 'command_sent' may be used uninitialized in this function
> drivers/scsi/qla2xxx/qla_attr.c:2146: warning: 'type' may be used uninitialized in this function
> 
> but I can't easily tell if they are false positives.

They seem to be false positives.  The unconditional initialisation is on
line 2191, and there's no use before then that I can find ... I also
don't see this error on my builds, so it looks like a toolchain issue.

James